# Post Processing API

> Herramienta integral de efectos de imagen que combina grano, corrección de color, desplazamiento cromático, desenfoque, viñeta, tinte y más

Aplica varios efectos a una imagen en una sola llamada, cada uno activado mediante un interruptor `enable_`: grano, corrección de color, aberración cromática, desenfoque, viñeta, parabolización y tinte. Cada efecto tiene sus propios rangos, como brillo y contraste de -100 a 100, radio de desenfoque de hasta 31 y desplazamientos de canal de -20 a 20. La entrada es una `image_url`.

- Model id: `post-processing`
- Made by: Utility
- Category: Image Editing
- Output: image
- Price: $0.001 / request (cheapest run $0.001 (1 API credit))
- Run: `POST https://api.doitong.com/v1/run/post-processing`
- Quote: `POST https://api.doitong.com/v1/quote/post-processing`
- Docs page: https://doitong.com/es-ES/developers/models/post-processing

## Pricing

Price: **$0.001 / request**. Billed once per request.

The full example input below costs $0.001 = 1 API credit (1 request × 1 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/post-processing` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `image_url` | `image` | string (image URL) | yes |  |  | URL de la imagen que se va a procesar. |
| `enable_grain` |  | boolean | no | `false` |  | Interruptor del efecto de grano de película. |
| `grain_intensity` |  | number | no | `0.4` | 0 – 1 | Intensidad del grano de película cuando el efecto está activado. |
| `grain_scale` |  | number | no | `10` | 1 – 100 | Escala del grano de película cuando el efecto está activado. |
| `grain_style` |  | enum (string) | no | `modern` | `modern`, `analog`, `kodak`, `fuji`, `cinematic`, `newspaper` | Estilo utilizado para el efecto de grano de película. |
| `enable_color_correction` |  | boolean | no | `false` |  | Interruptor de corrección de color. |
| `temperature` |  | number | no | `0` | -100 – 100 | Ajuste de la temperatura de color. |
| `brightness` |  | number | no | `0` | -100 – 100 | Ajuste del brillo de la imagen. |
| `contrast` |  | number | no | `0` | -100 – 100 | Ajuste del contraste de la imagen. |
| `saturation` |  | number | no | `0` | -100 – 100 | Ajuste de la saturación del color. |
| `gamma` |  | number | no | `1` | 0.2 – 2.2 | Ajuste de la gamma. |
| `enable_chromatic` |  | boolean | no | `false` |  | Interruptor de aberración cromática. |
| `red_shift` |  | integer | no | `0` | -20 – 20 | Cantidad de desplazamiento del canal rojo. |
| `red_direction` |  | enum (string) | no | `horizontal` | `horizontal`, `vertical` | Dirección de desplazamiento del canal rojo. |
| `green_shift` |  | integer | no | `0` | -20 – 20 | Cantidad de desplazamiento del canal verde. |
| `green_direction` |  | enum (string) | no | `horizontal` | `horizontal`, `vertical` | Dirección de desplazamiento del canal verde. |
| `blue_shift` |  | integer | no | `0` | -20 – 20 | Cantidad de desplazamiento del canal azul. |
| `blue_direction` |  | enum (string) | no | `horizontal` | `horizontal`, `vertical` | Dirección de desplazamiento del canal azul. |
| `enable_blur` |  | boolean | no | `false` |  | Interruptor del efecto de desenfoque. |
| `blur_type` |  | enum (string) | no | `gaussian` | `gaussian`, `kuwahara` | Método de desenfoque que se va a utilizar. |
| `blur_radius` |  | integer | no | `3` | 0 – 31 | Radio utilizado para el desenfoque. |
| `blur_sigma` |  | number | no | `1` | 0.1 – 10 | Valor sigma del desenfoque gaussiano. |
| `enable_vignette` |  | boolean | no | `false` |  | Interruptor del efecto de viñeta. |
| `vignette_strength` |  | number | no | `0.5` | 0 – 10 | Intensidad de la viñeta cuando el efecto está activado. |
| `enable_parabolize` |  | boolean | no | `false` |  | Interruptor del efecto parabolize. |
| `parabolize_coeff` |  | number | no | `1` | -10 – 10 | Coeficiente utilizado por el efecto parabolize. |
| `vertex_x` |  | number | no | `0.5` | 0 – 1 | Coordenada X del vértice. |
| `vertex_y` |  | number | no | `0.5` | 0 – 1 | Coordenada Y del vértice. |
| `enable_tint` |  | boolean | no | `false` |  | Interruptor del efecto de tinte de color. |
| `tint_strength` |  | number | no | `1` | 0.1 – 1 | Intensidad del efecto de tinte. |
| `tint_mode` |  | enum (string) | no | `sepia` | `sepia`, `red`, `green`, `blue`, `cyan`, `magenta`, `yellow`, `purple`, `orange`, `warm`, `cool`, `lime`, `navy`, `vintage`, `rose`, `teal`, `maroon`, `peach`, `lavender`, `olive` | Modo de color utilizado para aplicar el tinte. |
| `enable_dissolve` |  | boolean | no | `false` |  | Interruptor del efecto de disolución. |
| `dissolve_image_url` |  | string (image URL) | no | `` |  | URL de la segunda imagen, utilizada para el efecto de disolución. |
| `dissolve_factor` |  | number | no | `0.5` | 0 – 1 | Factor de mezcla del efecto de disolución. |
| `enable_dodge_burn` |  | boolean | no | `false` |  | Interruptor del efecto de sobreexposición y subexposición. |
| `dodge_burn_intensity` |  | number | no | `0.5` | 0 – 1 | Intensidad del efecto de sobreexposición y subexposición. |
| `dodge_burn_mode` |  | enum (string) | no | `dodge` | `dodge`, `burn`, `dodge_and_burn`, `burn_and_dodge`, `color_dodge`, `color_burn`, `linear_dodge`, `linear_burn` | Modo utilizado para el efecto de sobreexposición y subexposición. |
| `enable_glow` |  | boolean | no | `false` |  | Interruptor del efecto de resplandor. |
| `glow_intensity` |  | number | no | `1` | 0 – 5 | Intensidad del efecto de resplandor. |
| `glow_radius` |  | integer | no | `5` | 1 – 50 | Radio utilizado para desenfocar el resplandor. |
| `enable_sharpen` |  | boolean | no | `false` |  | Interruptor del efecto de enfoque. |
| `sharpen_mode` |  | enum (string) | no | `basic` | `basic`, `smart`, `cas` | Método de enfoque que se va a utilizar. |
| `sharpen_radius` |  | integer | no | `1` | 1 – 15 | Radio utilizado para el enfoque en el modo básico. |
| `sharpen_alpha` |  | number | no | `1` | 0.1 – 5 | Intensidad del enfoque en el modo básico. |
| `noise_radius` |  | integer | no | `7` | 1 – 25 | Radio utilizado para el ruido en el enfoque inteligente. |
| `preserve_edges` |  | number | no | `0.75` | 0 – 1 | Grado de conservación de los bordes. |
| `smart_sharpen_strength` |  | number | no | `5` | 0 – 25 | Intensidad del enfoque inteligente. |
| `smart_sharpen_ratio` |  | number | no | `0.5` | 0 – 1 | Proporción de mezcla del enfoque inteligente. |
| `cas_amount` |  | number | no | `0.8` | 0 – 1 | Intensidad del enfoque CAS. |
| `enable_solarize` |  | boolean | no | `false` |  | Indica si se aplica la solarización. |
| `solarize_threshold` |  | number | no | `0.5` | 0 – 1 | Umbral de solarización. |
| `enable_desaturate` |  | boolean | no | `false` |  | Indica si se aplica la desaturación. |
| `desaturate_factor` |  | number | no | `1` | 0 – 1 | Grado de desaturación. |
| `desaturate_method` |  | enum (string) | no | `luminance (Rec.709)` | `luminance (Rec.709)`, `luminance (Rec.601)`, `average`, `lightness` | Método utilizado para la desaturación. |

File parameters (`image`, `dissolve_image_url`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "image": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

A fuller example:

```json
{
  "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/post-processing?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/post-processing?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/post-processing", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "post-processing",
      "input": {
        "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "post-processing",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 1,
    "usd": "0.001",
    "charged": 1,
    "refunded": 0
  },
  "input": {
    "image_url": "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ]
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Imágenes resultantes del procesamiento. |

## Related models

- [Post Processing Blur](https://doitong.com/developers/models/post-processing/blur.md) (`post-processing/blur`): $0.001 / image
- [Post Processing Chromatic Aberration](https://doitong.com/developers/models/post-processing/chromatic-aberration.md) (`post-processing/chromatic-aberration`): $0.001 / image
- [Post Processing Color Correction](https://doitong.com/developers/models/post-processing/color-correction.md) (`post-processing/color-correction`): $0.001 / image
- [Post Processing Color Tint](https://doitong.com/developers/models/post-processing/color-tint.md) (`post-processing/color-tint`): $0.001 / image
- [Post Processing Desaturate](https://doitong.com/developers/models/post-processing/desaturate.md) (`post-processing/desaturate`): $0.001 / image
- [Post Processing Dissolve](https://doitong.com/developers/models/post-processing/dissolve.md) (`post-processing/dissolve`): $0.001 / image
- [Post Processing Dodge Burn](https://doitong.com/developers/models/post-processing/dodge-burn.md) (`post-processing/dodge-burn`): $0.001 / image
- [Post Processing Grain](https://doitong.com/developers/models/post-processing/grain.md) (`post-processing/grain`): $0.001 / image

## Links

- HTML page: https://doitong.com/developers/models/post-processing
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=post-processing
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/post-processing
